using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Ocean.OpsFramework.Common;
using Ocean.OpsFramework.Common.Search;
using Syncfusion.Drawing;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace RecordFiltering
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            gridGroupingControl2.DataSource = DataLoader.getChildData();
            
            gridGroupingControl2.TableControlCurrentCellChanged += OnCurrentCellValueChanged;
            gridGroupingControl2.ExceptionRaised += OnExceptionRaised;
            

        }

        private void OnExceptionRaised(object sender, ExceptionRaisedEventArgs e)
        {
            e.Cancel = true;
        }
              
        private void OnCurrentCellValueChanged(object sender, GridTableControlEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTableCellStyleInfo style = e.TableControl.Model[cc.RowIndex, cc.ColIndex] as GridTableCellStyleInfo;
            string columnName = style.TableCellIdentity.Column.MappingName;
            if (style.TableCellIdentity.Column != null && columnName == "DisableBasisCheck")
            {
                gridGroupingControl2.TableControl.Table.BeginEdit();
                gridGroupingControl2.TableControl.Table.EndEdit();
            }
        } 
    }

    internal class DataLoader
    {
        private int serialNumber;
        private string fullName;
        private string name;
        private double age;
        private string status;
        private bool disableBasisCheck;
        private double basis;

        public double Basis
        {
            get { return basis; }
            set { basis = value; }
        }        

        public int SerialNumber
        {
            get { return serialNumber; }
            set { serialNumber = value; }
        }

        public bool DisableBasisCheck
        {
            get { return disableBasisCheck; }
            set
            {
                disableBasisCheck = value;
                if (disableBasisCheck)
                    throw new Exception("Checked - Throws Exception");
                /*else
                    throw new Exception("Checked - Do Nothing"); ;*/
            }
        }

        public string FullName
        {
            get { return fullName; }
            set { fullName = value; }
        }

        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        public string Status
        {
            get { return status; }
            set { status = value; }
        }

        public double Age
        {
            get { return age; }
            set
            {
                if (!DisableBasisCheck)
                {
                    age = value;
                    Status = "New";
                }
                else
                {
                    Status = "Not Changed";
                }
            }
        }

        public DataLoader(string name, int age, string status)
        {
            this.name = name;
            this.age = age;
            this.status = status;
        }

        public DataLoader(int serialNumber, string fullName, bool disableBasisCheck, double basis)
        {
            this.serialNumber = serialNumber;
            this.fullName = fullName;
            this.disableBasisCheck = disableBasisCheck;
            this.basis = basis;
        }

        public static BindingList<DataLoader> getParentData()
        {
            BindingList<DataLoader> data = new BindingList<DataLoader>();
            data.Add(new DataLoader("srini", 1, String.Empty));
            data.Add(new DataLoader("rahul", 2, String.Empty));
            data.Add(new DataLoader("suhail", 3, String.Empty));
            data.Add(new DataLoader("mega", 4, String.Empty));
            data.Add(new DataLoader("raj", 5, String.Empty));
            data.Add(new DataLoader("chidu", 6, String.Empty));
            data.Add(new DataLoader("vinod", 7, String.Empty));
            data.Add(new DataLoader("michelle", 8, String.Empty));
            return data;
        }

        public static BindingList<DataLoader> getChildData()
        {
            BindingList<DataLoader> chilDictionary = new BindingList<DataLoader>();
            chilDictionary.Add(new DataLoader(1, "Srinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas GuptaSrinivas Gupta", false, 28));
            chilDictionary.Add(new DataLoader(2, "Rahul Parmar", false, 28.23));
            chilDictionary.Add(new DataLoader(3, "Suhail Shaikh", false, 33.770000000000003));
            chilDictionary.Add(new DataLoader(4, "Mega Viswam", false, 24.421052629999998));
            chilDictionary.Add(new DataLoader(5, "Raj Singh", false, 23));
            chilDictionary.Add(new DataLoader(6, "Chidu", false, 23));
            chilDictionary.Add(new DataLoader(7, "Vinod Tiwari", false, 24));
            chilDictionary.Add(new DataLoader(8, "Michelle Forster", false, 1.001));
            return chilDictionary;
        }
    }
}